;; Inventor-Man
;; Copyright 1996, Janet Marques. <jmarques@mit.edu>

(define pi 3.1415926585)
(define counter 0)
(define winlist '())

(define (send object message . args)
  (if (C++-object? object)
      (eval `(-> ,object ',message ,@args))
      (let ((method (get-method object message)))
	(if (not (no-method? method))
	    (apply method (cons object args))
	    (error "No method named" message)))))

(define (get-method object message)
  (object message))

(define (no-method method)
  'no-method)

(define (no-method? method)
  (eq? method 'no-method))

;(define (make-object)
;  (lambda (message)
;    (cond ((eq? message 'hi)
;	   (lambda (self arg1 arg2)
;	     (format #t "arg1: ~a arg2: ~a~%" arg1 arg2)))
;	  (else (no-method message)))))

(define root (new-SoSeparator))
(-> root 'ref)
(define event-callback (new-SoEventCallback))
(-> root 'addchild event-callback)
(define Viewer (new-SoXtExaminerViewer))
(-> Viewer 'SetSceneGraph root)
(-> viewer 'setViewing 0)
(define root-trans (new-SoTransform))
(-> root 'addchild root-trans)
(-> (-> root-trans 'rotation) 'setvalue 1 -.3 0 -4.5)
(-> Viewer 'show)
(define pellet-node (new-SoSeparator))
(-> root 'addchild pellet-node)
(define scale (new-SoScale))
(-> pellet-node 'addchild scale)
(-> (-> scale 'scalefactor) 'SetValue .01 .01 .01)

(define right-list (list '(-0.1 -0.7 0.0) '(0.7 -0.7 0.0) 
			 '(-0.7 -0.6 0.0) '(-0.4 -0.6 0.0) 
			 '(0.1 -0.6 0.0) '(0.4 -0.6 0.0) 
			 '(0.7 -0.6 0.0) '(-0.7 -0.5 0.0) 
			 '(-0.1 -0.5 0.0) '(0.5 -0.5 0.0) 
			 '(0.7 -0.5 0.0) '(-0.7 -0.4 0.0) 
			 '(-0.5 -0.4 0.0) '(-0.2 -0.4 0.0) 
			 '(0.5 -0.4 0.0) '(0.2 -0.1 0.0) 
			 '(0.2 0.0 0.0)  '(0.5 0.4 0.0) 
			 '(0.2 0.1 0.0) '(0.7 0.3 0.0) 
			 '(0.7 -0.3 0.0) '(0.0 0.2 0.0) 
			 '(-0.7 -0.2 0.0) '(-0.4 -0.2 0.0) 
			 '(-0.7 0.2 0.0) '(-0.7 -0.2 0.0)
			 '(-0.7 0.4 0.0) '(-0.7 -0.4 0.0)
			 '(0.4 -0.2 0.0) '(0.7 -0.2 0.0)
			 '(-0.4 -0.1 0.0) '(0.7 -0.1 0.0)
			 '(-0.4  0.0 0.0) '(0.4 0.0 0.0)
			 '(-0.1 0.7 0.0) '(0.7 0.7 0.0)
			 '(-0.7 0.6 0.0) '(-0.4 0.6 0.0)
			 '(0.1 0.6 0.0) '(0.4 0.6 0.0)
			 '(0.7 0.6 0.0) '(-0.7 0.5 0.0)
			 '(-0.1 0.5 0.0) '(0.5 0.5 0.0)
			 '(0.7 0.5 0.0) '(-0.7 0.4 0.0)
			 '(-0.5 0.4 0.0) '(-0.2 0.4 0.0)
			 '(-0.7 0.2 0.0) '(-0.4 0.2 0.0)
			 '(-0.7 0.2 0.0) '(-.7 0.4 0.0)
			 '(0.4 0.2 0.0) '(0.7 0.2 0.0)
			 '(-0.4 0.1 0.0) '(0.7 0.1 0.0)
			 '(0.2 0.4 0.0) '(0.2 -0.4 0.0)
			 '() ))

(define left-list (list  '(-0.7 -0.3 0.0) '(-0.7 -0.6 0.0)
			 '(-0.7 -0.5 0.0) '(-0.7 0.5 0.0) 
			 '(-0.7 -0.7 0.0) '(-0.7 -0.2 0.0)
			 '(-0.7 -0.1 0.0) '(-0.7 0.1 0.0)
			 '(-0.7 0.2 0.0) '(-0.7 0.3 0.0)
			 '(-0.7 0.6 0.0) '(-0.7 0.7 0.0)
			 '(-0.5 -0.5 0.0) '(-0.5 -0.4 0.0)
			 '(-0.5 0.5 0.0) '(-0.5 0.4 0.0)
			 '(-0.4 -0.6 0.0) '(-0.4 -0.2 0.0)
			 '(-0.4 -0.0 0.0) '(-0.4 0.2 0.0)
			 '(-0.4 0.6 0.0) '(-0.2 -0.4 0.0)
			 '(-0.2 0.4 0.0) '(-0.1 -0.6 0.0)
			 '(-0.1 0.6 0.0) '(0.1 0.7 0.0)
			 '(0.7 -0.6 0.0) '(-0.2 0.1 0.0)
			 '(0.7 -0.5 0.0) '(0.7 -0.4 0.0)
			 '(0.7 -0.2 0.0) '(-0.2 0.0 0.0)
			 '(-0.2 -0.1 0.0) '(0.0 0.2 0.0)
			 '(0.7 0.2 0.0) '(0.7  0.6 0.0) 
			 '(0.7 0.5 0.0) '(0.7 0.4 0.0)
			 '(0.5 -0.4 0.0) '(0.5  0.4 0.0)
			 '(0.4 -0.1 0.0) '(0.4 0.1 0.0)
			 '(0.4 -0.6 0.0) '(0.4 -0.2 0.0)
			 '(0.4 -0.0 0.0) '(0.4 0.2 0.0)
			 '(0.4 0.6 0.0) '(0.2 -0.4 0.0)
			 '(0.2 0.4 0.0) '(0.1 -0.7 0.0)
			 '(0.1 0.5 0.0) '(0.1 -0.5 0.0)
			 '(0.1 -0.7 0.0) '() ))

(define north-list (list  '(-0.7 -0.1 0.0) '(-0.7 0.7 0.0)
			  '(-0.6 -0.7 0.0) '(-0.6 -0.3 0.0)
			  '(-0.6 -0.1 0.0) '(-0.6 0.1 0.0)
			  '(-0.6 0.3 0.0) '(-0.6 0.7 0.0)
			  '(-0.5 -0.7 0.0) '(-0.5 -0.3 0.0)
			  '(-0.5 -0.1 0.0) '(-0.5 0.1 0.0)
			  '(-0.5 0.5 0.0) '(-0.5 0.7 0.0)
			  '(-0.4 -0.5 0.0) '(-0.4 0.3 0.0)
			  '(-0.4 0.7 0.0) '(-0.3 -0.7 0.0)
			  '(-0.3 -0.5 0.0) '(-0.3 -0.3 0.0)
			  '(-0.3 0.3 0.0) '(-0.3 0.5 0.0)
			  '(-0.3 0.7 0.0) '(-0.2 -0.7 0.0)
			  '(-0.2 -0.3 0.0) '(-0.2 0.1 0.0)
			  '(-0.2 0.5 0.0) '(-0.2 0.7 0.0)
			  '(-0.1 -0.5 0.0) '(-0.1 -0.3 0.0)
			  '(-0.1 0.1 0.0) '(-0.1 0.3 0.0)
			  '(-0.1 0.7 0.0) '(0.1 0.7 0.0)
			  '(0.7 -0.1 0.0) '(0.7 0.7 0.0)
			  '(0.6 -0.7 0.0) '(0.6 -0.3 0.0)
			  '(0.6 -0.1 0.0) '(0.6 0.1 0.0)
			  '(0.6 0.3 0.0) '(0.6 0.7 0.0)
			  '(0.5 -0.7 0.0) '(0.5 -0.3 0.0)
			  '(0.5 -0.1 0.0) '(0.5 0.1 0.0)
			  '(0.5 0.5 0.0) '(0.5 0.7 0.0)
			  '(0.4 -0.5 0.0) '(0.4 0.3 0.0)
			  '(0.4 0.7 0.0) '(0.3 -0.7 0.0)
			  '(0.3 -0.5 0.0) '(0.3 -0.3 0.0)
			  '(0.3 0.3 0.0) '(0.3 0.5 0.0)
			  '(0.3 0.7 0.0) '(0.2 -0.7 0.0)
			  '(0.2 -0.3 0.0) '(0.2 0.1 0.0)
			  '(0.2 0.5 0.0) '(0.2 0.7 0.0)
			  '(0.1 -0.5 0.0) '(0.1 -0.3 0.0)
			  '(0.1 0.1 0.0) '(0.1 0.3 0.0)
			  '(0.0 -0.6 0.0) '(0.0 -0.3 0.0)
			  '(0.0 0.3 0.0) '(0.0 0.6 0.0)
			  '(0.0 0.6 0.0) '(0.8 0.4 0.0)
			  '(-0.8 0.4 0.0) '(0.8 -0.4 0.0)
			  '(-0.8 -0.4 0.0) '() ))

(define south-list  (list '(-0.7 0.1 0.0) '(-0.7 -0.7 0.0)
			  '(-0.6 0.7 0.0) '(-0.6 0.3 0.0)
			  '(-0.6 0.1 0.0) '(-0.6 -0.1 0.0)
			  '(-0.6 -0.3 0.0) '(-0.6 -0.7 0.0)
			  '(-0.5 0.7 0.0) '(-0.5 0.3 0.0)
			  '(-0.5 0.1 0.0) '(-0.5 -0.1 0.0)
			  '(-0.5 -0.5 0.0) '(-0.5 -0.7 0.0)
			  '(-0.4 0.5 0.0) '(-0.4 -0.3 0.0)
			  '(-0.4 -0.7 0.0) '(-0.3 0.7 0.0)
			  '(-0.3 0.5 0.0) '(-0.3 0.3 0.0)
			  '(-0.3 -0.3 0.0) '(-0.3 -0.5 0.0)
			  '(-0.3 -0.7 0.0) '(-0.2 0.7 0.0)
			  '(-0.2 0.3 0.0) '(-0.2 -0.1 0.0)
			  '(-0.2 -0.5 0.0) '(-0.2 -0.7 0.0)
			  '(-0.1 0.5 0.0) '(-0.1 0.3 0.0)
			  '(-0.1 -0.1 0.0) '(-0.1 -0.3 0.0)
			  '(-0.1 -0.7 0.0) '(0.1 -0.7 0.0)
			  '(0.7 0.1 0.0) '(0.7 -0.7 0.0)
			  '(0.6 0.7 0.0) '(0.6 0.3 0.0)
			  '(0.6 0.1 0.0) '(0.6 -0.1 0.0)
			  '(0.6 -0.3 0.0) '(0.6 -0.7 0.0)
			  '(0.5 0.7 0.0) '(0.5 0.3 0.0)
			  '(0.5 0.1 0.0) '(0.5 -0.1 0.0)
			  '(0.5 -0.5 0.0) '(0.5 -0.7 0.0)
			  '(0.4 0.5 0.0) '(0.4 -0.3 0.0)
			  '(0.4 -0.7 0.0) '(0.3 0.7 0.0)
			  '(0.3 0.5 0.0) '(0.3 0.3 0.0)
			  '(0.3 -0.3 0.0) '(0.3 -0.5 0.0)
			  '(0.3 -0.7 0.0) '(0.2 0.7 0.0)
			  '(0.2 0.3 0.0) '(0.2 -0.1 0.0)
			  '(0.2 -0.5 0.0) '(0.2 -0.7 0.0)
			  '(0.1 0.5 0.0) '(0.1 0.3 0.0)
			  '(0.1 -0.1 0.0) '(0.1 -0.3 0.0)
			  '(0.0 0.6 0.0) '(0.0 -0.1 0.0)
			  '(0.0 -0.3 0.0) '(0.0 -0.6 0.0)
			  '(0.0 -0.6 0.0) '(0.0 0.4 0.0)
			  '(0.8 0.4 0.0)  '(-0.8 -0.4 0.0)
			  '(-0.8 0.4 0.0) '(0.8 -0.4 0.0)
			  '(0.0 0.3 0.0) '() ))

(define (make-inven-man)
  (define inven-root (new-SoSeparator))
  (send root 'addchild inven-root)
  (define inven-trans (new-SoTransform))
  (send inven-root 'addchild inven-trans)
  (define inven-mat (new-SoMaterial))
  (send inven-root 'addchild inven-mat)
  (-> (-> inven-mat 'DiffuseColor) 'SetValue 0.0 0.0 .6)
  (define inven-man (new-SoSphere))
  (send inven-root 'addchild inven-man)
  (-> (-> inven-man 'radius) 'SetValue .05)
  (-> (-> inven-trans 'translation) 'SetValue 0.0 -0.3 0.0)
  (define callback-info (new-SchemeSoCBInfo))
  (-> callback-info 'ref)
  (-> (-> callback-info 'callbackName) 'setValue "key-event-cb")
  (-> (-> callback-info 'affectsNode) 'setValue inven-trans)
  (-> event-callback 'addEventCallback (SoKeyboardEvent::getClassTypeId)
      (get-scheme-event-callback-cb)
      (void-cast callback-info))
  (lambda (message)
    (cond ((eq? message 'SetInitial)
	   (lambda (self)
	     (-> (-> inven-trans 'translation) 'SetValue 0.0 -0.3 0.0)))
	  ((eq? message 'setcolor)
	   (lambda (self r g b)
	     (send (send inven-mat 'diffuseColor) 'SetValue r g b)))
	  ((eq? message 'setLocation)
	   (lambda (self x1 y1 z1)
	     (send (send inven-trans 'translation) 'SetValue x1 y1 z1)))
	  ((eq? message 'SetRadius)
	   (lambda (self radius)
	     (send (send inven-man 'Radius) 'SetValue radius)))
	  ((eq? message 'right)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))
	       (if (member (vector->list coord)
			   (list '(0.8 0.4 0.0) 
				 '(0.8 -0.4 0.0) '()))   
		   (send (send inven-trans 'translation) 
			 'setValue (- 0.0 x1) y1 z1)			
		   (if (not (member (vector->list coord) right-list))
		       (begin
			 (send (send inven-trans 'translation) 'setValue 
			       (+ x1 0.1) y1 z1)
			 (if (not (member (vector->list coord)
					  (list '(-0.8 0.4 0.0) 
						'(-0.8 -0.4 0.0) '()))) 
			     (begin
			       (put-pellet (vector (* 100 x1) (* 100 y1) 0.0) 					     0 0 .6)
			       (win? coord)))))))))
	  ((eq? message 'left)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))
	       (if (member (vector->list coord)
			   (list '(-0.8 0.4 0.0) '(-0.8 -0.4 0.0) '()))   
		   (send (send inven-trans 'translation) 
			 'setValue (- 0.0 x1) y1 z1)			
		   (if (not (member (vector->list coord) left-list))
		       (begin
			 (send (send inven-trans 'translation) 'setValue 
			       (- x1 0.1) y1 z1)
			 (if (not (member (vector->list coord)
					  (list '(0.8 0.4 0.0) 
						'(0.8 -0.4 0.0) '())))
			     (begin
			       (put-pellet (vector (* 100 x1) (* 100 y1) 0.0) 
					   0 0 .6)
			       (win? coord)))))))))
	  ((eq? message 'north)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))	              
	       (if (not (member (vector->list coord) north-list))
		   (begin
		     (send (send inven-trans 'translation) 'setValue 
			   x1 (+ y1 0.1) z1)
		     (put-pellet (vector (* 100 x1) (* 100 y1) 0.0) 
				 0 0 .6)
		     (win? coord))))))
	  ((eq? message 'south)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))               
	       (if (not (member (vector->list coord) south-list))
		   (begin
		       (send (send inven-trans 'translation) 'setValue 
			     x1 (- y1 0.1) z1)
		       (put-pellet (vector (* 100 x1) (* 100 y1) 0.0) 
				   0 0 .6)
		       (win? coord))))))
	  ((eq? message 'nowhere)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))
	       (send (send inven-trans 'translation) 'setValue x1 y1 z1))))
	  ((eq? message 'getlocation)
	   (let ((coord (-> (-> (-> inven-trans 'translation) 
				'GetValue) 'GetValue)))
	     (lambda (self)
	       (vector (/ (round (* 10 (vector-ref coord 0))) 10)
		       (/ (round (* 10 (vector-ref coord 1))) 10)
		       (/ (round (* 10 (vector-ref coord 2))) 10))))))))
  
(define (key-event-cb user-data event-node)
  (let ((event (send event-node 'getEvent)))
    (cond ((= 1 (SO_KEY_PRESS_EVENT event LEFT_ARROW))
	   (send inventor-man 'left))
	  ((= 1 (SO_KEY_PRESS_EVENT event RIGHT_ARROW))
	   (send inventor-man 'right))
	  ((= 1 (SO_KEY_PRESS_EVENT event UP_ARROW))
	   (send inventor-man 'north))
	  ((= 1 (SO_KEY_PRESS_EVENT event DOWN_ARROW))
	   (send inventor-man 'south))
	  (else (send inventor-man 'nowhere)))
    (send event-node 'setHandled)))

(define inventor-man (make-inven-man))
(load "maze.scm")

(define (make-ghost x y r g b)
  (define ghost-root (new-SoSeparator))
  (send root 'addchild ghost-root)
  (define ghost-trans (new-SoTransform))
  (send ghost-root 'addchild ghost-trans)
  (define ghost-mat (new-SoMaterial))
  (send ghost-root 'addchild ghost-mat)
  (-> (-> ghost-mat 'DiffuseColor) 'SetValue r g b)
  (define ghost (new-SoSphere))
  (send ghost-root 'addchild ghost)
  (-> (-> ghost 'radius) 'SetValue .035)
  (-> (-> ghost-trans 'translation) 'SetValue x y 0.0)
  (lambda (message)
    (cond ((eq? message 'SetInitial)
	   (lambda (self)
	     (-> (-> ghost-trans 'translation) 'SetValue 0.0 0.0 0.0)))
	  ((eq? message 'setcolor)
	   (lambda (self r g b)
	     (send (send ghost-mat 'diffuseColor) 'SetValue r g b)))
	  ((eq? message 'setLocation)
	   (lambda (self x1 y1 z1)
	     (send (send ghost-trans 'translation) 'SetValue x1 y1 z1)))
	  ((eq? message 'SetRadius)
	   (lambda (self radius)
	     (send (send ghost 'Radius) 'SetValue radius)))
	  ((eq? message 'right)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2))) 	   
	       (if (member (vector->list coord)
			   (list '(0.8 0.4 0.0) 
				 '(0.8 -0.4 0.0) '())) 
   		   (send (send ghost-trans 'translation) 
			 'setValue (- 0.0 x1) y1 z1)			
		   (if (not (member (vector->list coord) right-list))
		       (send (send ghost-trans 'translation) 'setValue 
			     (+ x1 0.1) y1 z1)
		       (send self 'south))))))
	  ((eq? message 'left)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))  
	       (if (member (vector->list coord)
			   (list '(-0.8 0.4 0.0) '(-0.8 -0.4 0.0) '()))   
   		   (send (send ghost-trans 'translation) 
			 'setValue (- 0.0 x1) y1 z1)			
		   (if (not (member (vector->list coord) left-list))
		       (send (send ghost-trans 'translation) 'setValue 
			     (- x1 0.1) y1 z1)
		       (send self 'north))))))
	  ((eq? message 'north)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))
               (if (not (member (vector->list coord) north-list))
		   (send (send ghost-trans 'translation) 'setValue 
			 x1 (+ y1 0.1) z1)
		   (send self 'right)))))
	  ((eq? message 'south)
	   (lambda (self)
	     (let* ((coord (send self 'getlocation))
		    (x1 (vector-ref coord 0))
		    (y1 (vector-ref coord 1))
		    (z1 (vector-ref coord 2)))
               (if (not (member (vector->list coord) south-list))
		   (send (send ghost-trans 'translation) 'setValue 
			 x1 (- y1 0.1) z1)
		   (send self 'left)))))
	  ((eq? message 'getlocation) 
	   (lambda (self)
	     (let ((coord (-> (-> (-> ghost-trans 'translation) 
				  'GetValue) 'GetValue)))
	       (vector (/ (round (* 10 (vector-ref coord 0))) 10)
		       (/ (round (* 10 (vector-ref coord 1))) 10)
		       (/ (round (* 10 (vector-ref coord 2))) 10))))))))


(define ghost1 (make-ghost 0.1 0.0 1 .4 1))
(define ghost2 (make-ghost -0.1 0.0 1 .4 .4))

(define ghost1-brain   
  (lambda (user-data sensor)
    (let* ((init-coord (send ghost1 'getlocation))
	   (x1 (vector-ref init-coord 0))
	   (y1 (vector-ref init-coord 1))
	   (final-coord (send inventor-man 'getlocation))
	   (x2 (vector-ref final-coord 0))
	   (y2 (vector-ref final-coord 1)))
      (if (not (= (send (send win-text-root 'whichChild) 'getValue) -3))
	  (if (equal? init-coord final-coord)
	      (send (send game-over-root 'whichChild) 'setValue -3)
	      (if (> (abs (- x1 x2)) (abs (- y1 y2)))
		  (if (> x1 x2)
		      (send ghost1 'left)
		      (send ghost1 'right))
		  (if (> y1 y2)
		      (send ghost1 'south)
		      (send ghost1 'north))))))))

;; set up callback

(define callback-info1 (new-SchemeSoCBInfo))
(-> callback-info1 'ref)
(-> (-> callback-info1 'callbackName) 
    'setValue "ghost1-brain")

(define timer-sensor1
  (new-SoTimerSensor (get-scheme-sensor-cb) 
		     (void-cast callback-info1)))

(-> timer-sensor1 'setInterval
    (new-SbTime (/ 1.0 1))) ; repeat 1 times/sec

(define ghost2-brain
  (lambda (user-data sensor)
    (let* ((init-coord (send ghost2 'getlocation))
	   (x1 (vector-ref init-coord 0))
	   (y1 (vector-ref init-coord 1))
	   (final-coord (send inventor-man 'getlocation))
	   (x2 (vector-ref final-coord 0))
	   (y2 (vector-ref final-coord 1)))
      (if (not (= (send (send win-text-root 'whichChild) 'getValue) -3))
	  (if (equal? init-coord final-coord)
	      (send (send game-over-root 'whichChild) 'setValue -3)
	      (if (< (abs (- x1 x2)) (abs (- y1 y2)))
		  (if (> x1 x2)
		      (send ghost2 'left)
		      (send ghost2 'right))
		  (if (> y1 y2)
		      (send ghost2 'south)
		      (send ghost2 'north))))))))

;; set up callback

(define callback-info2 (new-SchemeSoCBInfo))
(-> callback-info2 'ref)
(-> (-> callback-info2 'callbackName) 
    'setValue "ghost2-brain")

(define timer-sensor2
  (new-SoTimerSensor (get-scheme-sensor-cb) 
		     (void-cast callback-info2)))

(-> timer-sensor2 'setInterval
    (new-SbTime (/ 1.0 1))) ; repeat 2 times/sec

(define (put-pellet coord r g b)
  (let* ((x1 (vector-ref coord 0))
	 (y1 (vector-ref coord 1))
         (z1 (vector-ref coord 2)))
    (define pellet (new-SoSeparator))
    (send pellet-node 'addchild pellet)
    (define pellet-trans (new-SoTransform))
    (send pellet 'addchild pellet-trans)
    (define pellet-mat (new-SoMaterial))
    (send pellet 'addchild pellet-mat)
    (define pellet-piece (new-SoCylinder))
    (send pellet 'addchild pellet-piece)
    (send (send pellet-piece 'height) 'setvalue 3)
    (send (send pellet-trans 'translation) 'SetValue x1 y1 z1)
    (send (send pellet-trans 'rotation) 'SetValue 0 0 1 (/ pi 3))
    (send (send pellet-mat 'diffuseColor) 'SetValue r g b)))

(define (put-pellets coord1 coord2 r g b)
  (let* ((x1 (vector-ref coord1 0))
	 (y1 (vector-ref coord1 1))
	 (x2 (vector-ref coord2 0))
	 (y2 (vector-ref coord2 1)))
    (cond ((> x1 x2)
	   (put-pellet coord1 r g b)
	   (put-pellets (vector (- x1 10) y1 0) coord2 r g b))
	  ((< x1 x2)
	   (put-pellet coord1 r g b)
	   (put-pellets (vector (+ x1 10) y1 0) coord2 r g b))
	  ((> y1 y2)
	   (put-pellet coord1 r g b)
	   (put-pellets (vector x1 (- y1 10) 0) coord2 r g b))
	  ((< y1 y2)
	   (put-pellet coord1 r g b)
	   (put-pellets (vector x1 (+ y1 10) 0) coord2 r g b)))))

(load "pellets.scm")



(define (game-over)
  (define root (new-SoSwitch))
  (send root 'ref)
  (define xlate (new-SoTranslation))
  (send (send xlate 'translation) 'setValue -1 0 .15)
  (send root 'addChild xlate)
  (define font (new-SoFont))
  (send (send font 'size) 'setValue .4)
  (send root 'addChild font)
  (define text-mat (new-SoMaterial))
  (send (send text-mat 'diffuseColor) 'setValue 0 0.5 0)
  (send root 'addChild text-mat)
  (define text (new-SoText3))
  (send root 'addChild text)
  (send (send text 'string) 'set1Value 0 (new-SbString "Game Over"))
  (send root 'unrefNoDelete)
  root)

(define (build-new-game-text)
  (define root (new-SoSelection))
  (send root 'ref)
  (send (send root 'policy) 'setValue SoSelection::ENUM_TOGGLE)
  (define text-pick-style (new-SoPickStyle))
  (send (send text-pick-style 'style) 'setValue SoPickStyle::BOUNDING_BOX)
  (send root 'addChild text-pick-style)
  (define xlate (new-SoTranslation))
  (send (send xlate 'translation) 'setValue .2 .8 .2)
  (send root 'addChild xlate)
  (define font (new-SoFont))
  (send (send font 'size) 'setValue .2)
  (send root 'addChild font)
  (define text-mat (new-SoMaterial))
  (send (send text-mat 'diffuseColor) 'setValue 0.0 0.5 0.0)
  (send root 'addChild text-mat)
  (define text (new-SoText3))
  (send root 'addChild text)
  (send (send text 'string) 'set1Value 0 (new-SbString "New Game"))
  (define cb-info (new-SchemeSoCBInfo))
  (send cb-info 'ref)
  (send (send cb-info 'callbackName) 'setValue "new-game-cb")
  (send root 'addSelectionCallback (get-scheme-selection-path-cb) (void-cast cb-info))
  (send root 'addDeselectionCallback (get-scheme-selection-path-cb) (void-cast cb-info))
  (send root 'unrefNoDelete)
  root)

(define new-game-text-root (build-new-game-text))
(send root 'addChild new-game-text-root)

(define (new-game-cb user-data path)
  (new-game))

(define game-over-root (game-over))
(send root 'addChild game-over-root) 

(define (win-text)
  (define root (new-SoSwitch))
  (send root 'ref)
  (define xlate (new-SoTranslation))
  (send (send xlate 'translation) 'setValue -.8 0 .15)
  (send root 'addChild xlate)
  (define font (new-SoFont))
  (send (send font 'size) 'setValue .4)
  (send root 'addChild font)
  (define text-mat (new-SoMaterial))
  (send (send text-mat 'diffuseColor) 'setValue 0 0.5 0)
  (send root 'addChild text-mat)
  (define text (new-SoText3))
  (send root 'addChild text)
  (send (send text 'string) 'set1Value 0 (new-SbString "You Won"))
  (send root 'unrefNoDelete)
  root)

(define win-text-root (win-text))
(send root 'addChild win-text-root) 

(define (win)
  (send (send win-text-root 'whichChild) 'SetValue -3))
	   
(define (win? coord)
   (if (> counter 133)
       (win)
       (if (not (member coord winlist))
	   (begin
	     (set! winlist (cons coord winlist))
	     (set! counter (+ counter 1))
	     (if (> counter 133)
		 (win))))))

(define (start-game)
  (send ghost1 'left)
  (send ghost1 'north)
  (send ghost1 'north)
  (send ghost1 'north)
  (-> Viewer 'render)
  (-> timer-sensor1 'schedule)
  (send ghost2 'right)
  (send ghost2 'north)
  (send ghost2 'north)
  (send ghost2 'north)
  (-> Viewer 'render)
  (-> timer-sensor2 'schedule))

(define (new-game)
  (send inventor-man 'setInitial)
  (send ghost1 'setLocation 0.1 0.0 0.0)
  (send ghost2 'setLocation -0.1 0.0 0.0)
  (load "pellets.scm")
  (set! counter 0)
  (set! winlist '())
  (send (send game-over-root 'whichChild) 'setValue -1)
  (send (send win-text-root 'whichChild) 'setValue -1)
  (start-game))

(start-game)
  




 
  

















